//+------------------------------------------------------------------+
//|                                                      Range V1.0  |
//|                                                                  |
//|              Copyright  2005, Jason Robinson                    |
//|               (jasonrobinsonuk,  jnrtrading)                     |
//|                http://www.jnrtrading.co.uk                       |
//|                                                                  |
//|               THIS VERSION IS FROM MY WEBSITE                    |
//|         (unless it has been posted by me on a forum)             |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Robinson"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  FireBrick
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 
extern color  textColor       = White;

double higher[];
double lower[];
double noChange[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0, higher);   SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0, "Higher");
   SetIndexBuffer(1, lower);    SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1, "Lower");
   SetIndexBuffer(2, noChange); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2, "No Change");
   SetIndexBuffer(3, trend);
   
      
   IndicatorShortName("Range (H L nC)");

   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
//

int deinit() 
{
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {
      higher[i]   = EMPTY_VALUE;
      lower[i]    = EMPTY_VALUE;
      noChange[i] = EMPTY_VALUE;
      trend[i]    = 0;
      if (High[i] - Low[i] >  High[i+1] - Low[i+1]) trend[i] = 1;
      if (High[i] - Low[i] <  High[i+1] - Low[i+1]) trend[i] =-1;
      if (High[i] - Low[i] == High[i+1] - Low[i+1]) trend[i] = 0;
      if (trend[i] == 1) higher[i]   = High[i] - Low[i]; 
      if (trend[i] ==-1) lower[i]    = High[i] - Low[i]; 
      if (trend[i] == 0) noChange[i] = High[i] - Low[i];   
      
        ObjectDelete("Range");
        ObjectCreate("Range", OBJ_TEXT, 1, Time[i], High[i] - Low[i]);
        ObjectSetText("Range", "             " + DoubleToStr(High[i] - Low[i], 4), 10, "Verdana", textColor);
   }
manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"higher");
         if (trend[whichBar] ==-1) doAlert(whichBar,"lower");
      
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Range "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Range " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Range "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

